package f4.interfaces;

/**
 * This list obeys the contract
 * @author hajo
 */
public class List implements IList {

    private final int[] elems;

    public List(int[] elems) {
        this.elems = elems;
    }

    @Override
    public IList subList(int beginIndex) {
        int len = elems.length - beginIndex;
        int[] e = new int[len];
        copyOffset(e, elems, beginIndex);
        return new List(e);
    }

    @Override
    public IList subList(int beginIndex, int endIndex) {
        int len = endIndex - beginIndex;
        int[] e = new int[len];
        copyOffset(e, elems, beginIndex);
        return new List(e);
    }

    private void copyOffset(int[] dest, int[] src, int offset) {
        for (int i = 0; i < dest.length; i++) {
            dest[i] = src[offset+i];
        }
    }

    @Override
    public int get(int index) {
        return elems[index];
    }

    @Override
    public int length() {
        return elems.length;
    }
}
