package f4.interfaces;

import java.util.Arrays;

/**
 * This list also obeys the contract but have
 * a different implementation
 * @author hajo
 */
public class List2 implements IList {

    private final int[] elems;

    public List2(int[] elems) {
        this.elems = elems;
    }

    @Override
    public IList subList(int beginIndex) {
        int[] e = Arrays.copyOfRange(elems, beginIndex, elems.length);
        return new List2(e);
    }

    @Override
    public IList subList(int beginIndex, int endIndex) {
        int[] e = Arrays.copyOfRange(elems, beginIndex, endIndex);
        return new List2(e);
    }

    @Override
    public int get(int index) {
        return elems[index];
    }

    @Override
    public int length() {
        return elems.length;
    }
}
